package cbg.spy.inspectors;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class InspectorMap {
	protected Map inspectorMap;
	
	public InspectorMap() {
		super();
		inspectorMap = new HashMap();
	}

	public void addInspector(String type, Inspector inspector) {
		List inspectors = (List) inspectorMap.get(type);
		if(inspectors == null) {
			inspectors = new LinkedList();
			inspectorMap.put(type, inspectors);
		}
		inspectors.add(inspector);
	}
	private Iterator iteratorFor(Class clazz) {
		if(clazz == null) return null;
		String controlName = clazz.getName();
		List inspectors = (List) inspectorMap.get(controlName);
		if(inspectors != null) return inspectors.iterator();
		return iteratorFor(clazz.getSuperclass());
	}

	public Iterator iteratorFor(Object control) {
		return iteratorFor(control.getClass());
	}


	public Iterator iteratorFor(SpyEvent spyEvent) {
		return iteratorFor(spyEvent.control);
	}




}
