package cbg.spy.inspectors;

import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.SubContributionItem;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;

import cbg.spy.views.Info;

public class ToolbarInspector extends InspectorA {
	public ToolbarInspector(Info info) {
		super(info);
	}
	public void inspect(SpyEvent event) {
		ToolBar toolBar = (ToolBar)event.control;
		ToolItem toolItem = toolBar.getItem(event.local);
		if(toolItem == null) return;
		Object item = toolItem.getData();
		info.println("ToolItem Data: " + toolItem.getData());
		if(item instanceof SubContributionItem) {
			item = ((SubContributionItem)item).getInnerItem();
		}
		if(item instanceof ActionContributionItem) {
			IAction action = ((ActionContributionItem)item).getAction();
			if(action == null) return;
			info.println("\tAction: " + action);
			ImageDescriptor imageDescriptor = action.getImageDescriptor();
			if(imageDescriptor != null) info.println("\tImage Descriptor: " + imageDescriptor);			
		}
	}
}
